# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`nm`](#nm): Manage NetworkManager

#### Private Classes

* `nm::install`
* `nm::service`

### Defined types

* [`nm::connection`](#nm--connection): Create a .nmconnection file

## Classes

### <a name="nm"></a>`nm`

Manage NetworkManager

#### Parameters

The following parameters are available in the `nm` class:

* [`conf`](#-nm--conf)
* [`connections`](#-nm--connections)
* [`purge_connections`](#-nm--purge_connections)

##### <a name="-nm--conf"></a>`conf`

Data type: `Optional[Variant[String[1], Hash[String, Hash]]]`

If a String:
Verbatim content of `NetworkManager.conf`.

If a Hash:
Hash of data to serialize to `NetworkManager.conf`.

See: https://networkmanager.dev/docs/api/latest/nm-settings-keyfile.html

Default value: `undef`

##### <a name="-nm--connections"></a>`connections`

Data type: `Optional[Hash[String, Hash]]`

Hash of nm::connection resources to create

Default value: `undef`

##### <a name="-nm--purge_connections"></a>`purge_connections`

Data type: `Boolean`

If `true` unmanaged connections will be purged.

Default value: `true`

## Defined types

### <a name="nm--connection"></a>`nm::connection`

Create a .nmconnection file

#### Parameters

The following parameters are available in the `nm::connection` defined type:

* [`content`](#-nm--connection--content)
* [`ensure`](#-nm--connection--ensure)

##### <a name="-nm--connection--content"></a>`content`

Data type: `Optional[Variant[String[1], Hash[String, Hash]]]`

If a String:
Verbatim content of .nmconnection "keyfile".

If a Hash:
Hash of data to serialize to a .nmconnection "keyfile".

See: https://networkmanager.dev/docs/api/latest/nm-settings-keyfile.html

Default value: `undef`

##### <a name="-nm--connection--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

If connection file should be present or absent.

Default value: `'present'`

